"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libview' }"

WinWorkstation subclass:#WinPrinter
	instanceVariableNames:'printerInfo'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Printing'
!

!WinPrinter primitiveDefinitions!
%{
#define TRACE_ALL_EVENTS      /* */

#define COUNT_RESOURCES       /* */
#define COUNT_BMP_RESOURCES   /* */
#define DEBUG_DELETEOBJECT    /* */
#define DEBUG_DC_REUSE        /* */
#define LOCK_DEBUG

#define ADJUSTWINDOW
#define ALWAYSTRUECOLOR
#define WIN32THREADS

/* #define DEBUGMASK            /* */
#define SET_FOCUS_IN_WINTHREAD
#define SET_CURSOR_IN_WINTHREAD
#define DELAY_ENTER_LEAVE_WHILE_IN_SIZE_MOVE /* */
#define xxBEEP_IN_WINTHREAD    /* */
#define COMPRESS_WINDOWPOSCHANGED

#define USE_DRAW_MUTEX
#define xxLATE_GENERATE_EXPOSE              /* get update region from stx thread */


#undef INT
#define INT WIN_INT
#undef Array
#define Array WIN_Array
#undef Number
#define Number WIN_Number
#undef Method
#define Method WIN_Method
#undef Point
#define Point WIN_Point
#undef Rectangle
/* #define Rectangle WIN_Rectangle */
#undef True
#define True WIN_True
#undef False
#define False WIN_False
#undef Block
#define Block WIN_Block
#undef Context
#define Context WIN_Context
#undef Date
#define Date WIN_Date
#undef Time
#define Time WIN_Time
#undef Delay
#define Delay WIN_Delay
#undef Signal
#define Signal WIN_Signal
#undef Set
#define Set WIN_Set

#include <stdio.h>
#include <errno.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

/*#include <stdarg.h>   */

#ifdef __BORLANDC__
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <shellapi.h>
# include <sys\timeb.h>
# include <dir.h>
#else
# define _USERENTRY /**/
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <sys\timeb.h>
#endif
#include <commdlg.h>

#include <process.h>

#ifdef __DEF_Array
# undef Array
# define Array __DEF_Array
#endif
#ifdef __DEF_Number
# undef Number
# define Number __DEF_Number
#endif
#ifdef __DEF_Method
# undef Method
# define Method __DEF_Method
#endif
#ifdef __DEF_Point
# undef Point
# define Point __DEF_Point
#endif
#ifdef __DEF_Rectangle
# undef Rectangle
# define Rectangle __DEF_Rectangle
#else
# undef Rectangle
#endif
#ifdef __DEF_Block
# undef Block
# define Block __DEF_Block
#endif
#ifdef __DEF_Context
# undef Context
# define Context __DEF_Context
#endif
#ifdef __DEF_Date
# undef Date
# define Date __DEF_Date
#endif
#ifdef __DEF_Time
# undef Time
# define Time __DEF_Time
#endif
# ifdef __DEF_Set
#  undef Set
#  define Set __DEF_Set
# endif
# ifdef __DEF_Signal
#  undef Signal
#  define Signal __DEF_Signal
# endif
# ifdef __DEF_Delay
#  undef Delay
#  define Delay __DEF_Delay
# endif
#undef INT

#define INT int

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HBITMAPVAL(o)       (HBITMAP)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))

#define WIDECHAR unsigned short

#ifdef LATER
  /* for multi-WIN display support, we need this as an instance var (as below)
   * however, there are many more places, where a single static datum is
   * used currently - therefore dont care for this - at least now.
   */
# define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#endif

#define ISCONNECTED         1

struct gcData {
    union {
        HDC         __hDC;
        struct gcData *__nextFree;
    } u;
    HWND        hWnd;
    HBITMAP     hBitmap;
    HBITMAP     save_hBitmap;
    HBITMAP     hMask;
    short       clipX;
    short       clipY;
    short       clipW;
    short       clipH;
    char        clipping;
    char        clipByChildren;
    char        bkMode;
    char        bitmapColorBitCount;
    short       maskOrgX;
    short       maskOrgY;
    short       lineWidth;
    short       fontAscent;
    int         lStyle;   /* is lineStyle | joinStyle | capStyle */
    int         rop2;
    int         bitbltrop2;
    COLORREF    fgColor;
    COLORREF    bgColor;
    HFONT       hFont;
    HFONT       save_hFont;
    HPEN        hPen;
    HPEN        save_hPen;
    HBRUSH      hBrush;
    HBRUSH      save_hBrush;
};
#define _hDC u.__hDC

#define WIN32PADDING 32


#ifdef DEBUG
# define PRINTF(x)              { printf x;}
# define CPRINTF(x)             /* { printf x;} */
# define DPRINTF(x)             /* { printf x;} */
#else
# define PRINTF(x)              /* */
# define CPRINTF(x)             /* */
# define DPRINTF(x)             /* */
#endif


/*
 * globally cached - never released
 */

typedef int (*intf)(int);

/*
 * keep the windows cursor and others local in the HWND struct.
 */

typedef struct {
        HCURSOR         hCursor;
        HBRUSH          viewBgBrush;  /* if that is nil, it has a solid bg color */
        COLORREF        viewBgColor;
        int             eventMask;
        short           flag;         /* LI_ - flags bits */
        short           minWidth;
        short           maxWidth;
        short           minHeight;
        short           maxHeight;
        short           bw;
        unsigned char   iconified;
        unsigned char   viewGravity;
        unsigned char   unmapping;
#if 0
        short           bgOffsX;      /* bg-pattern offset */
        short           bgOffsY;      /* bg-pattern offset */
#endif
        short           mouseX;       /* last mouseX */
        short           mouseY;       /* last mouseY */
        COLORREF        bdColor;
} localWindowInfo;
typedef localWindowInfo *plocalWindowInfo;

typedef struct createWindowInfo {
        localWindowInfo *localWindowInfo;  /* in param */
        HANDLE          newWinHandle;      /* out param */
        char            *windowName;       /* in params */
        char            *className;
        int             winStyleBits;
        int             winStyleBitsEx;
        HANDLE          parentHandle;
        int             x;
        int             y;
        int             dx;
        int             dy;
        HANDLE          hCreateEvent;
        short           infoWasRead;
        unsigned short  sequenceNr;
        unsigned        errCode;
} createWindowInfo;


%}
! !

!WinPrinter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!WinPrinter class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 28-07-2006 / 19:52:01 / fm"
!

on: aPrinterInfo 
|newWinPrinter|
newWinPrinter := self new.
newWinPrinter printerInfo: aPrinterInfo.
^ newWinPrinter

    "Created: / 04-08-2006 / 12:57:06 / fm"
! !

!WinPrinter methodsFor:'accessing'!

getLogicalPixelSizeX
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:40 / fm"
!

getLogicalPixelSizeY
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:29 / fm"
!

height
    ^ height

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

height:something
    height := something.

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

printerInfo: aPrinterInfo
    printerInfo :=aPrinterInfo

    "Created: / 04-08-2006 / 12:54:09 / fm"
!

width
    ^ width

    "Created: / 28-07-2006 / 18:13:06 / fm"
!

width:something
    width := something.

    "Created: / 28-07-2006 / 18:13:06 / fm"
! !

!WinPrinter methodsFor:'drawing'!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:ignoredDrawableId with:aDC
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{
    int __x, __y, w, h;
    float angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
        angle1 = (float)(__intVal(startAngle));
    else if (__isFloat(startAngle)) {
        angle1 = (float) __floatVal(startAngle);
    } else if (__isShortFloat(startAngle)) {
        angle1 = __shortFloatVal(startAngle);
    } else goto bad;

    if (__isSmallInteger(angle))
        angle2 = (float)(__intVal(angle));
    else if (__isFloat(angle)) {
        angle2 = (float) __floatVal(angle);
    } else if (__isShortFloat(angle)) {
        angle2 = __shortFloatVal(angle);
    } else goto bad;

    if (angle2 <= 0) {
        RETURN (self);
    }

    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height))
     {
        POINT p;
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        DWORD clr = 0 /* 0xFFFFFFFF */;    
        HANDLE prevPen, hPen = CreatePen(PS_SOLID, 1, clr);
        double xB, yB, xE, yE, xR, yR;

        w = __intVal(width);
        h = __intVal(height);
        __x = __intVal(x);
        __y = __intVal(y);

            xR = w / 2;
            yR = h / 2;
            if (angle2 - angle1 >= 360) {
                xB = xE = __x + xR + 0.5;
                yB = yE = __y /*+ yR + 0.5*/;
            } else {
                double sin(), cos();
                float rad1, rad2;

                if (angle1 <= 180)
                  angle1 = 180 - angle1;
                else
                  angle1 = 360 + 180 - angle1;
                angle2 = angle1 - angle2;
                /* sigh - compute the intersections ... */
                rad1 = (angle1 * 3.14159265359) / 180.0;
                rad2 = (angle2 * 3.14159265359) / 180.0;
                xB = cos(rad1) * xR;
                yB = sin(rad1) * yR;
                xE = cos(rad2) * xR;
                yE = sin(rad2) * yR;
                xB = __x + xR - xB + 0.5;
                yB = __y + yR - yB + 0.5;
                xE = __x + xR - xE + 0.5;
                yE = __y + yR - yE + 0.5;
            }
            prevPen = SelectObject(hDC, hPen);
            DPRINTF(("Arc x=%d y=%d w=%d h=%d xB=%d xE=%d yB=%d yE=%d a1=%f a2=%f\n",__x,__y,w,h,(int)xB,(int)xE,(int)yB,(int)yE,angle1,angle2));
            Arc(hDC,
                __x, __y,
                __x + w, __y + h,
                (int)xB, (int)yB,
                (int)xE, (int)yE);

            SelectObject(hDC, prevPen);

        RETURN ( self );
    }
    bad: ;
%}.
    self primitiveFailed

    "Created: / 07-08-2006 / 10:40:27 / fm"
    "Modified: / 07-08-2006 / 14:44:21 / fm"
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:ignoredDrawableId with:aDC
    "draw a line. If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        DWORD clr = 0 /* 0xFFFFFFFF */;
        HANDLE prevPen, hPen;

        int __x1 = __intVal(x1), __y1 = __intVal(y1);

/*      DPRINTF(("displayLine: %d/%d -> %d/%d\n",
                    __intVal(x0), __intVal(y0),
                    __x1, __y1));
*/
        hPen = CreatePen(PS_SOLID, 1, clr);
        prevPen = SelectObject(hDC, hPen);

        MoveToEx(hDC, __intVal(x0), __intVal(y0), NULL);

        LineTo(hDC, __x1, __y1);

        /*
         * end-point ...
         */
        LineTo(hDC, __x1+1, __y1);

        SelectObject(hDC, prevPen);


        RETURN ( self );
    }
%}
!

displayPolygon:aPolygon in:aDrawableId with:aDC
    "draw a polygon, the argument aPolygon is a Collection of individual points,
     which define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.

%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddressLike(aDC)
     /* && __isExternalAddress(aDrawableId) */
     && __isSmallInteger(numberOfPoints)) {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        POINT p;
        DWORD clr = 0 /* 0xFFFFFFFF */;
        HANDLE prevPen, hPen;

        num = __intVal(numberOfPoints);

        for (i=0; i<num; i++) {
            point = __AT_(aPolygon, __MKSMALLINT(i+1));
            if (! __isPoint(point)) goto fail;
            px = _point_X(point);
            py = _point_Y(point);
            if (! __bothSmallInteger(px, py)) {
                goto fail;
            }
        }

        hPen = CreatePen(PS_SOLID, 1, clr);
        prevPen = SelectObject(hDC, hPen);

        for (i=0; i<num; i++) {
            point = __AT_(aPolygon, __MKSMALLINT(i+1));
            px = _point_X(point);
            py = _point_Y(point);
            p.x = __intVal(px);
            p.y = __intVal(py);
            if (i == 0) {
                MoveToEx(hDC, p.x, p.y, NULL);
            } else {
                if (i == (num-1)) {
                    PolylineTo(hDC, &p, 1);
                } else {
                    LineTo(hDC, p.x, p.y);
#ifdef PRE_04_JUN_04
                    /*
                     * end-point ...
                     */
                    LineTo(hDC, p.x+1, p.y);
#endif
                }
            }
        }
        SelectObject(hDC, prevPen);

        RETURN ( self );
    }
fail: ;
%}

    "Created: / 07-08-2006 / 14:46:55 / fm"
!

displayRectangleX:x y:y width:width height:height in:ignoredDrawableId with:aDC
    "draw a rectangle. If the coordinates are not integers, an error is triggered."

%{ 
    int w, h;
    int xL, yT;
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));

        xL = __intVal(x);
        yT = __intVal(y);
        w = __intVal(width);
        h = __intVal(height);

        DPRINTF(("displayRectangle: %d/%d -> %d/%d\n",
                        xL, yT, w, h));

        if ((w >= 0) && (h >= 0)) {
            DWORD clr = 0 /* 0xFFFFFFFF */;
            HANDLE prevPen, hPen = CreatePen(PS_SOLID, 1, clr);

            prevPen = SelectObject(hDC, hPen);
            MoveToEx(hDC, xL, yT, NULL);
            LineTo(hDC, xL+w, yT);       // to top-right
            LineTo(hDC, xL+w, yT+h);     // to bot-right
            MoveToEx(hDC, xL, yT, NULL); // back to top-left
            LineTo(hDC, xL, yT+h);       // to bot-left
            LineTo(hDC, xL+w+1, yT+h);   // move pen one pixel more

            SelectObject(hDC, prevPen);
        }
        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:18:25 / fm"
!

displayString:aString from:index1 to:index2 x:x y:y in:ignoredDrawableId with:aDC opaque:opaque 
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
    int nInstBytes;

    if (__isExternalAddressLike(aDC)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y))
    {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        int pX, pY;
        pX = __intVal(x);
        pY = __intVal(y);

        if (opaque == true) {
            SetBkMode(hDC, OPAQUE);
        } else {
            SetBkMode(hDC, TRANSPARENT);
        }
        SetTextColor(hDC, 0);
        SetBkColor(hDC, 0xFFFFFFFF);

        cls = __qClass(aString);

        i1 = __intVal(index1) - 1;
        if (i1 >= 0) {
            i2 = __intVal(index2) - 1;
            if (i2 < i1) {
                goto ret;
            }

            cp = _stringVal(aString);
            l = i2 - i1 + 1;

            if ((cls == @global(String)) || (cls == @global(Symbol))) {
                n = _stringSize(aString);
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string1: %s pos=%d/%d l=%d hDC=%x hWnd=%x\n", cp, pX, pY,l,hDC,_HWNDVal(aDrawableId)));

                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
            cp += nInstBytes;
            n = __byteArraySize(aString) - nInstBytes;

            if (__isBytes(aString)) {
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            /* Unicode */
            if (__isWords(aString)) {
                n = n / 2;
                if (i2 < n) {
                    WIDECHAR *w_cp = (WIDECHAR *)cp;

                    w_cp += i1;

                    if (! TextOutW(hDC, pX, pY, w_cp, l)) {
                        PRINTF(("TextoutW failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }
        }
ret:
        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:35:19 / fm"
!

displayString:aString from:index1 to:index2 x:x y:y in:ignoredDrawableId with:aDC opaque:opaque fontAscent:fontAscent
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
    int nInstBytes;

    if (__isExternalAddressLike(aDC)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y))
    {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        int pX, pY;
        pX = __intVal(x);
        pY = __intVal(y);
        pY -= __intVal(fontAscent);

        if (opaque == true) {
            SetBkMode(hDC, OPAQUE);
        } else {
            SetBkMode(hDC, TRANSPARENT);
        }
        SetTextColor(hDC, 0);
        SetBkColor(hDC, 0xFFFFFFFF);

        cls = __qClass(aString);

        i1 = __intVal(index1) - 1;
        if (i1 >= 0) {
            i2 = __intVal(index2) - 1;
            if (i2 < i1) {
                goto ret;
            }

            cp = _stringVal(aString);
            l = i2 - i1 + 1;

            if ((cls == @global(String)) || (cls == @global(Symbol))) {
                n = _stringSize(aString);
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string1: %s pos=%d/%d l=%d hDC=%x hWnd=%x\n", cp, pX, pY,l,hDC,_HWNDVal(aDrawableId)));

                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
            cp += nInstBytes;
            n = __byteArraySize(aString) - nInstBytes;

            if (__isBytes(aString)) {
                if (i2 < n) {
                    cp += i1;
                    CPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
                    if (l > 32767) {
                        l = 32767;
                    }
                    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
                        PRINTF(("Textout failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }

            /* Unicode */
            if (__isWords(aString)) {
                n = n / 2;
                if (i2 < n) {
                    WIDECHAR *w_cp = (WIDECHAR *)cp;

                    w_cp += i1;

                    if (! TextOutW(hDC, pX, pY, w_cp, l)) {
                        PRINTF(("TextoutW failed. %d\n", GetLastError()));
                    }
                    goto ret;
                }
            }
        }
ret:
        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:35:19 / fm"
! !

!WinPrinter methodsFor:'graphic context stuff'!

setFont:aFontId in:aDC
    "set font to be drawn in"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aDC)
     && __isExternalAddress(aFontId))
    {
        HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
        HGDIOBJ prevFont, hFont;

        hFont = _HGDIOBJVal(aFontId);
        prevFont = SelectObject(hDC, hFont);

        RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 04-08-2006 / 12:32:53 / fm"
! !

!WinPrinter methodsFor:'initialization'!

initialize
    self initializeDeviceResourceTables

    "Modified: / 28-07-2006 / 19:52:07 / fm"
! !

!WinPrinter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/WinPrinter.st,v 1.9 2006-08-25 10:52:55 cg Exp $'
! !
